﻿using System.Collections.Generic;
using System.Linq;
using TSLab.DataSource;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace Z_TickV
{
    // Объем покупок/продаж
    [HandlerCategory("ZIP")]
    public class Z_TickV : IBar2DoubleHandler
    {
        [HandlerParameter(Name = "Направление", NotOptimized = true)]
        public TradeDirection Direction { get; set; }

        public IList<double> Execute(ISecurity security)
        {
            var count = security.Bars.Count;
            var values = new double[count];
            for (var i = 0; i < count; i++)
            {
                var trades = security.GetTrades(i);
                var value = 0.0;
                for (var k = 0; k < trades.Count; k++)
                {
                    var trd = trades[k];
                    value += trd.Direction == Direction ? trd.Quantity : 0;
                }

                values[i] = value;
            }
            return values;
        }
    }
}